#!/bin/bash

# génération d'un fichier de 200 ko
./Generateur.sh fic200k.bin 50000
rm data/copy/fic200k.bin 2> /dev/null
mv fic200k.bin data/source
./Generateur.sh fic100k.bin 25000
rm data/copy/fic100k.bin 2> /dev/null
mv fic100k.bin data/source
./Generateur.sh fic400k.bin 100000
rm data/copy/fic400k.bin 2> /dev/null
mv fic400k.bin data/source


# Lancement de deux serveurs
./Serveur.sh 4545 &
serveur1=$!

./Serveur.sh 4546 &
serveur2=$!

# on attend le démarage des serveurs
sleep 1

# Import du fichier
./Client.sh fic200k.bin &
client1=$!

# Import du fichier
./Client.sh fic400k.bin &
client2=$!

# Import du fichier
./Client.sh fic100k.bin &
client3=$!

wait $client1 $client2 $client3

#vérification

if diff data/copy/fic200k.bin data/source/fic200k.bin && diff data/copy/fic400k.bin data/source/fic400k.bin && diff data/copy/fic100k.bin data/source/fic100k.bin; then
    echo test OK
else
    echo test KO
fi

# on tue les 2 serveurs
kill $serveur1 $serveur2

exit 0
