package tsp.csc4509.tpnote;

import static tsp.csc4509.common.Log.GEN;
import static tsp.csc4509.common.Log.COMM;

import java.io.IOException;

import org.apache.logging.log4j.Level;

import tsp.csc4509.blockfile.BlockFile;
import tsp.csc4509.common.Log;

/**
 * Classe d'application du client.
 * @author 
 *  Eric Lallet.
 *
 */
public final class AppliClient {
	/**
	 * Nombre d'arguments attendus par le main.
	 */
	private static final int NBARGS = 1;

	/**
	 * position du nom du fichier dans le tableau d'arguments.
	 */
	private static  final int FILENAMEARG = 0;

	/**
	 * 
	 */
	private AppliClient() {

	}

	/**
	 * 
	 * @param args
	 * 			args[0]: file name
	 */
	public static void main(final String[] args) throws IOException {
		if (args.length != NBARGS) {
			System.err.println("usage: client <nom d'un fichier>");
			return;
		}
		String fileName = args[FILENAMEARG];
		Log.setLevel(GEN, Level.INFO);
		Log.setLevel(COMM, Level.INFO);
		// créer le fichier info dans le répertoire File.INFO pour être sûr
		// qu'il existe. Ce fichier devrait pré-exister à la demande de
		// service, mais durant les tests, nous sommes ammenés à ajouter
		// régulièrement des nouveaux fichiers.
		BlockFile.createFile(fileName);

		Client client = new Client(fileName);
		client.importFile();


	}

}
