package tsp.csc4509.tpnote;

import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.SocketChannel;
import java.util.concurrent.BlockingQueue;

import tsp.csc4509.blockfile.BlockFile;
import tsp.csc4509.tcp.TcpSocketSynchrone;

/**
 * Runnable du pool de threads du serveur.
 * @author EricPro
 *         Eric Lallet.
 */
public class ServerRunnable implements Runnable {

	/**
	 * file de communication avec le thread principal.
	 */
	private BlockingQueue<SocketChannel> queue;

	/**
	 * Constructeur qui iniatialise l'attribut queue.
	 * @param queue
	 *        référence à placer dans l'attribut queue.
	 */
	public ServerRunnable(final BlockingQueue<SocketChannel> queue) {
		this.queue = queue;

	}

	@Override
	public void run() {

		while (true) {
			try {

				SocketChannel rwChan;

				rwChan = queue.take();
				TcpSocketSynchrone client = new TcpSocketSynchrone(rwChan);

				Request request;

				request = (Request) client.receiveObject();

				RandomAccessFile rin = new RandomAccessFile(BlockFile.SOURCE + "/" + request.getFilename(), "r");
				FileChannel fcin = rin.getChannel();
				rin.seek(request.getOffset());

				ByteBuffer buffer = ByteBuffer.allocate(request.getSize());
				fcin.read(buffer);
				buffer.flip();
				client.sendBuffer(buffer);
				rin.close();
				fcin.close();
				client.close();

			} catch (Exception e) {
				// rien à faire. On retourne attendre la prochaine requête.
				
			} 
		}



	}

}
